VERSION 4.00
Begin VB.Form frmDemo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Transparent Bitmaps"
   ClientHeight    =   3975
   ClientLeft      =   1365
   ClientTop       =   1485
   ClientWidth     =   5130
   Height          =   4380
   Left            =   1305
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   265
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   342
   Top             =   1140
   Width           =   5250
   Begin VB.PictureBox Picture2 
      ClipControls    =   0   'False
      Enabled         =   0   'False
      Height          =   465
      Left            =   450
      Picture         =   "frmDemo.frx":0000
      ScaleHeight     =   405
      ScaleWidth      =   495
      TabIndex        =   11
      Top             =   3240
      Width           =   555
   End
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Clear"
      Height          =   375
      Index           =   1
      Left            =   4005
      TabIndex        =   9
      Top             =   3240
      Width           =   875
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Display"
      Default         =   -1  'True
      Height          =   375
      Index           =   0
      Left            =   3105
      TabIndex        =   8
      Top             =   3240
      Width           =   875
   End
   Begin VB.Frame Frame2 
      Caption         =   "Destination"
      Height          =   1275
      Left            =   3105
      TabIndex        =   4
      Top             =   1755
      Width           =   1770
      Begin VB.OptionButton Option2 
         Caption         =   "CommandButton"
         Height          =   195
         Index           =   2
         Left            =   180
         TabIndex        =   7
         Top             =   900
         Width           =   1545
      End
      Begin VB.OptionButton Option2 
         Caption         =   "PictureBox"
         Height          =   195
         Index           =   1
         Left            =   180
         TabIndex        =   6
         Top             =   630
         Value           =   -1  'True
         Width           =   1230
      End
      Begin VB.OptionButton Option2 
         Caption         =   "Form"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   5
         Top             =   360
         Width           =   1230
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Source"
      Height          =   1410
      Left            =   3105
      TabIndex        =   0
      Top             =   135
      Width           =   1770
      Begin VB.CheckBox Check1 
         Caption         =   "Visible"
         Height          =   195
         Left            =   450
         TabIndex        =   3
         Top             =   585
         Value           =   1  'Checked
         Width           =   825
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Picture Object"
         Height          =   195
         Index           =   1
         Left            =   180
         TabIndex        =   2
         Top             =   990
         Width           =   1455
      End
      Begin VB.OptionButton Option1 
         Caption         =   "PictureBox"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   1
         Top             =   360
         Value           =   -1  'True
         Width           =   1230
      End
   End
   Begin VB.PictureBox Picture1 
      ClipControls    =   0   'False
      Enabled         =   0   'False
      Height          =   3120
      Left            =   1485
      ScaleHeight     =   3060
      ScaleWidth      =   1350
      TabIndex        =   10
      Top             =   225
      Width           =   1410
   End
   Begin VB.CommandButton Command2 
      Height          =   3165
      Left            =   1485
      TabIndex        =   12
      Top             =   225
      Visible         =   0   'False
      Width           =   1410
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'TRANSPARENT BITMAP DEMONSTRATION
'================================
'This demo project uses the TransBmpH sub located in the
'file TransBmpH.mod. TransBmpH is a 32-bit modification
'of the original 16-bit code published in a Microsoft
'Knowledge Base article. This demonstration was written
'to be A)mildly efficient, while B)still easy to follow.
'-------------------------------------------------------------
'Note: Windows performs palette negotiation/arbitration
'in order to display images in colors as close as possible
'to the originals. This is especially noticeable in 256-color
'mode. Depending on the number of colors in the bitmaps used
'and the colors in use elsewhere on the display, windows may
'alter the value of the "transparent" color in the bitmap
'when it is displayed, thus defeating the purpose. The simplest
'solution is to use a "transparent" color when creating the
'bitmap that is certain to be in use (white or black is always
'a safe bet).

Option Explicit

Dim Pobj1 As Picture 'OLE Picture Object

Private Sub Check1_Click()
    'toggle source PictureBox visibility
    Picture2.Visible = Not Picture2.Visible
End Sub

Private Sub Command1_Click(Index As Integer)
    Dim Dest As Object
    'An object variable is used here because it's generally
    'not a good idea to store and use the Hwnd property.
    'The Hwnd should be passed directly to the called routine
    'whenever possible.
    
    If Index = 0 Then 'display
        If Option2(0).Value = True Then 'destination is form
            Set Dest = frmDemo
        ElseIf Option2(1).Value = True Then 'destination is picturebox
            Set Dest = Picture1
        Else 'destination is commandbutton
            Set Dest = Command2
        End If
    
        '*****display the image********
        'White(&hFFFFFF or RGB(255,255,255)) is used as transparent color
        'in this project's sample images.
        If Option1(0).Value = True Then 'source is picturebox
            TransBmpH Dest.hwnd, Picture2.Picture, 2&, 2&, &HFFFFFF
        Else 'source is picture object
            TransBmpH Dest.hwnd, Pobj1.Handle, 7&, 7&, &HFFFFFF
        End If
    Else 'clear
        Me.Cls
        Picture1.Cls
        Command2.Refresh
    End If
End Sub

Private Sub Command2_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    '(Not the preferred method of putting images on buttons, but it
    'suites the purpose of the demonstration.)
    
    DoEvents 'First let VB finish re-drawing the button.
    'Otherwise the image would get immediately trashed.
    If Option1(0).Value = True Then 'source is picturebox
        TransBmpH Command2.hwnd, Picture2.Picture, 3&, 3&, RGB(255, 255, 255)
    Else
        TransBmpH Command2.hwnd, Pobj1.Handle, 3&, 3&, RGB(255, 255, 255)
    End If
End Sub

Private Sub Command2_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Option1(0).Value = True Then 'source is picturebox
        TransBmpH Command2.hwnd, Picture2.Picture, 2&, 2&, RGB(255, 255, 255)
    Else
        TransBmpH Command2.hwnd, Pobj1.Handle, 2&, 2&, RGB(255, 255, 255)
    End If
End Sub

Private Sub Form_Load()
    Set Pobj1 = LoadPicture(App.Path & "\" & "gkey.bmp")
    'Note: Pobj1 could also be loaded from a project RESource,
    'thus eliminating the need for distribution of separate
    '.bmp files with the application.
End Sub

Private Sub Form_Paint()
    'Must re-do display of transparent bitmap(s) here if there is
    'any chance the form might be re-painted, as when covered and
    're-exposed, or if restored from minimized state.
    'In this case, just the last bitmap. In the case of a compound
    'image that is the result of two or more transparent bitmaps,
    'each step would have to be repeated.
    'Alternatively if the destination is a Form or PictureBox, setting
    'the Autoredraw property to True would eliminate having to do
    'anything here.
    
    Command1_Click 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set Pobj1 = Nothing 'release resources when no longer needed
    Set frmDemo = Nothing
End Sub

Private Sub Option2_Click(Index As Integer)
    'destination selector
    If Index = 1 Then 'picturebox
        Picture1.Visible = True
        Command2.Visible = False
    ElseIf Index = 2 Then 'commandbutton
        Picture1.Visible = False
        Command2.Visible = True
    End If
End Sub
